import com.cycling74.max.*;
import java.io.*;
import java.net.*;

public class tcpClient extends MaxObject
{

		Socket dqdSocket = null;  
	 	 DataOutputStream os = null;
  		 BufferedReader is = null;

		 String responseLine;
		String addressString = "localhost";
		int portSetting = 7126;
		boolean aThreadIsOpen = false;

	private static final String[] INLET_ASSIST = new String[]{
		"inlet 1 help"
	};
	private static final String[] OUTLET_ASSIST = new String[]{
		"outlet 1 help"
	};

	private void startSocket() {
		try {
            dqdSocket = new Socket(addressString,portSetting);
            os = new DataOutputStream(dqdSocket.getOutputStream());
            is = new BufferedReader(new InputStreamReader(dqdSocket.getInputStream()));
        } catch (UnknownHostException e) {
            post("Don't know about host: hostname");
        } catch (IOException e) {
            post("Couldn't get I/O for the connection to: hostname");
        }
	}

	private void killSocket() {
		try {	
			os.close();
			is.close();
			dqdSocket.close();
		}
		catch (IOException e) {
			post("IOException:  " + e);
		}
	}
	
	public tcpClient(Atom[] args)
	{
		declareInlets(new int[]{DataTypes.ALL,DataTypes.ALL});
		declareOutlets(new int[]{DataTypes.ALL});
		
		setInletAssist(INLET_ASSIST);
		setOutletAssist(OUTLET_ASSIST);
		declareAttribute("address", "getAddress", "setAddress");
    	declareAttribute("port", "getPort", "setPort");

	//	startSocket();
	}


    private void setAddress(String s) {
    	addressString = s;
	//	killSocket();
	//	startSocket();
    }

    public Atom[] getAddress() {
    		return new Atom[] {Atom.newAtom("address " + addressString)};
    }
    
    private void setPort(int i) {
    	portSetting = i;
    }
	
	public void open() {
		close();
		startSocket();
	}

	public void close() {
		if (dqdSocket != null && os != null && is != null) {
			killSocket();
		}
	}

    private Atom[] getPort() {
    		return new Atom[] {Atom.newAtom("port " + portSetting)};
    }
    
	public void bang()
	{	
	if (!aThreadIsOpen) {
		//create a new thread to listen 
		Thread t = new Thread(){ 
			public void run() 
			{ 
				aThreadIsOpen = true;
				if (dqdSocket != null && os != null && is != null) {
					try {
 	 					responseLine = is.readLine();
						if (responseLine != " ") {
							//post(responseLine);
							outlet(0,new Atom[]{Atom.newAtom(responseLine)});
						}
				    } catch (IOException e) {
 	       		        System.err.println("IOException:  " + e);
	       	 		}
				}
				aThreadIsOpen = false;
			}
		}; 
		t.start(); //start the thread executing
	}
	}
    
	public void inlet(int i)
	{
	
	}
    
	public void inlet(float f)
	{
	}
    
    
	//public void list(Atom[] list)
	//{
	
	//}

	public void send (String inputString)
	{
		try {
 			os.writeBytes(inputString + "\n");
		} catch (UnknownHostException e) {
   	        post("Trying to connect to unknown host: " + e);
 	    } catch (IOException e) {
       	    post("IOException:  " + e);
        }
	}
    
}









